var _path = '/PDF Reader Pro';
var _pendingReloads = [];
var _reloadingDisabled = 0;
var currDirs = [];
var currFiles = [];
var checkNum = 0;
var rename = null;
var deleteCon = null;

function formatFileSize(bytes) {
  if (bytes >= 1000000000) {
    return (bytes / 1000000000).toFixed(2) + ' G';
  }
  if (bytes >= 1000000) {
    return (bytes / 1000000).toFixed(2) + ' M';
  }
  return (bytes / 1000).toFixed(2) + ' K';
}

function _disableReloads() {
  _reloadingDisabled += 1;
}

function _enableReloads() {
  _reloadingDisabled -= 1;
  
  if (_pendingReloads.length > 0) {
    _reload(_pendingReloads.shift());
  }
}

function _reload(path) {
  if (_reloadingDisabled) {
    if ($.inArray(path, _pendingReloads) < 0) {
      _pendingReloads.push(path);
    }
    return;
  }
  _disableReloads();
  $.ajax({
    url: '/filelist',
    type: 'GET',
    data: {dir: path},
    dataType: 'json'
  }).fail(function(jqXHR, textStatus, errorThrown) {
  }).done(function(data, textStatus, jqXHR) {
    $('.empty-status').hide();
    var scrollPosition = $(document).scrollTop();
    
    $(".folder").empty();
    if (path == "/PDF Reader Pro") {
      $(".folder").append('<span class="active">PDF Reader Pro</span>');
    } else {
      var components = path.split("/").slice(1);
      for (var i = 0; i < components.length - 1; ++i) {
        var subpath = "/" + components.slice(0, i + 1).join("/");
        $(".folder").append('<span class="folder-item" data-path="' + subpath + '">' + components[i] + '</span><span class="arrow">&nbsp;>&nbsp;</span>');
      }
      $(".folder > .folder-item").click(function(event) {
        _reload($(this).data("path"));
        event.preventDefault();
      });
      $(".folder").append('<span class="active">' + components[components.length - 1] + '</span>');
    }
    _path = data.mCurrentDir;
    $(".listing").empty();
    
    $('.operate-container').show();
    $('.operate-container .delete-files').addClass('disabled');
    checkNum = 0;
    rename = null;
    if ($('.delete-loading').hasClass('show')) {
      $('.delete-loading').removeClass('show'); 
    }
    $('.floder-list-title .name').text('Name')
    if ($('.floder-list-title .checkbox').hasClass('active')) {
      $('.floder-list-title .checkbox').removeClass('active');
    }
    currDirs = [];
    currDirs = [];
    if (data.mDirInfo.length === 0 && data.mFileInfo.length === 0) {
      $('.empty-status').show();
      return
    }
    for (var i = 0, dir; dir = data.mDirInfo[i]; ++i) {
      $(tmpl("template-listing-dir", dir)).data(dir).appendTo(".listing");
      currDirs.push(dir = data.mDirInfo[i].mName);
    }
    for (var i = 0, file; file = data.mFileInfo[i]; ++i) {
      file.url = _path === "/" ? _path + encodeURIComponent(file.mName) : _path  + '/' + encodeURIComponent(file.mName);
      var names = file.mName.split('.');
      var name = names[names.length - 1].toLowerCase();
      if (!(/cbz|doc|docx|epub|html|pdf|ppt|pptx|svg|tiff|txt|xls|xlsx|xps|png|jpg|jpeg/.test(name))) {
        file.format = 'other';
      } else {
        if (/svg|png|jpg|jpeg/.test(name)) {
          file.format = 'image';
        } else {
          file.format = name;
        }
      }
      $(tmpl("template-listing-file", file)).data(file).appendTo(".listing");
      currFiles.push(dir = data.mFileInfo[i].mName);
    }
    
    $(".button-open").click(function(event) {
      var name = $(this).data("name");
      var path = _path === '/' ? _path + name : _path + '/' + name;
      _reload(path);
    });
    
    $(document).scrollTop(scrollPosition);
  }).always(function() {
    _enableReloads();
  });
}

$(document).ready(function() {
  document.ondragstart = function() {
    return false;
  };
  var flag = navigator.userAgent.match(/(phone|pad|pod|iPhone|iPod|ios|iPad|Android|Mobile|BlackBerry|IEMobile|MQQBrowser|JUC|Fennec|wOSBrowser|BrowserNG|WebOS|Symbian|Windows Phone)/i);
  if (flag) {
    $('.upload-text .drop-text').hide();
    $('.empty-sub-text-min').show();
    $('.empty-sub-text').hide();
  }
  $('.dropzone').on('dragover', function(e) {
    e.preventDefault();
    var dropZone = $('.dropzone'),
      timeout = window.dropZoneTimeout;
    if (!timeout) {
      $('.dropCover').show();
    } else {
      clearTimeout(timeout);
    }
    var node = e.target;
    do {
      if (node === dropZone[0]) {
        break;
      }
      node = node.parentNode;
    } while (node != null);
    window.dropZoneTimeout = setTimeout(function () {
      window.dropZoneTimeout = null;
      $('.dropCover').hide();
    }, 100);
  })

  $('.dropzone').on('drop', function(e) {
    e.stopPropagation();
    e.preventDefault();
    if (rename) {
      resetEdit()
    }
  })
  
  $(".upload-file").click(function(event) {
    $("#fileupload").click();
  });
  
  $("#fileupload").click(function(event) {
    event.stopPropagation();
    if (rename) {
      resetEdit()
    }
  });
  
  $("#fileupload").fileupload({
    dropZone: $('.dropzone'),
    pasteZone: null,
    autoUpload: true,
    sequentialUploads: true,
    // limitConcurrentUploads: 2,
    url: '/upload',
    type: 'POST',

    start: function(e) {
      $(".uploading").show();
    },
    
    stop: function(e) {
      if ($('.uploading .uploading-list').children().length > 0) return
      $(".uploading").hide();
    },

    add: function(e, data) {
      var file = data.files[0];
      var names = file.name.split('.')
      var name = names[names.length - 1].toLowerCase()
      if (!(/pdf|txt|epub|png|jpg|jpeg|doc|docx|xls|xlsx|ppt|pptx/.test(name))) return
      data.context = $(tmpl("template-uploads", {
        name: file.name
      })).appendTo(".uploading .uploading-list");
      var jqXHR = data.submit();
      data.context.find(".btn").click(function(event) {
        jqXHR.abort();
        data.context.remove();
        if ($('.uploading .uploading-list').children().length > 0) return
        $(".uploading").hide();
      });
    },

    progress: function(e, data) {
      var progress = parseInt(data.loaded / data.total * 100, 10);
      data.context.find('.wait').removeClass('wait')
      data.context.find('.wait-text').hide()
      data.context.find(".progress-bar").css("width", progress + "%");
      data.context.find(".progress-num").text(progress + "%")

    },

    done: function(e, data) {
      _reload(_path);
      data.context.remove();
    },

    fail: function(e, data) {
      if (data.errorThrown != "abort") {
        data.context.find(".file-info .progress").hide();
        data.context.find(".file-info .progress-num").hide();
        data.context.find(".wait-text").html('<img src="pdf_pro/img/file_ic_warn.png" alt=""><span class="error">Error</span>').show();
      }
    },
    
  });
  
  $.ajax({
    methods: 'GET',
    url: '/device',
    dataType: 'json',
  }).fail(function(jqXHR, textStatus, errorThrown) {
    $('.device').hide();
  }).done(function(data, textStatus, jqXHR) {
    $('.device .name').text(data.mDeviceName)
  })

  _reload("/PDF Reader Pro");

  function handleMkdir (e) {
    e.stopPropagation()
    var val = rename.el.val().trim();
    if (!val) {
      resetEdit();
      return
    }
    if (currDirs.length) {
      for (var i = 0; i < currDirs.length; i++) {
        if (val === currDirs[i]) {
          handleAlert('Same folder name exists, please modify.', 1000);
          rename.el.focus();
          return
        }
      }
    }
    if (!checkName(val, rename)) return
    $.ajax({
      type: 'POST',
      url: '/renameormakedir?type=mkdir&filename=' + encodeURIComponent(val) + '&filepath=' + _path,
      dataType: 'json',
    }).done(function(){
      _reload(_path);
    }).fail(function() {
      $('.listing').children().first().remove();
      rename = null
      handleAlert('Fail to create new folder.')
      return
    })
  }

  $('.add-folder').click(function (e) {
    e.stopPropagation()
    window.scrollTo({
      top: 0,
      behavior: 'smooth'
    });
    if (rename) {
      if (rename.type === 'dir') {
        rename.el.select()
      } else {
        var val = rename.el.val()
        var formate = val.split('.')[val.split('.').length - 1]
        var index = val.indexOf(formate)
        selectText(rename.el[0], 0, index - 1)
      }
      return
    }
    $('.listing').prepend('<div class="floder-list"><span class="checkbox" data-checked="off"></span><div class="name"><span class="dir button-open" data-name="test"><img src="pdf_pro/img/file_ic_folder.png" alt=""></span><div class="edit-container"><input class="mkdir-input" type="text"><span class="mkdir-confirm"></span></div><div class="operate"><span class="rename" data-type="dir"></span><span class="delete" data-type="dir"></span></div></div><div class="count">-</div><div class="date">-</div><div class="size">-</div></div>');
    $('.listing .floder-list').eq(0).find('.name').css('justify-content', 'flex-start')
    $('.listing .floder-list').eq(0).find('.edit-container').show()
    $('.listing .floder-list').eq(0).find('.operate').hide()
    var $edit = $('.listing .floder-list').eq(0).find('.edit-container').find('input')
    rename = {
      el: $edit,
      type: 'dir',
      val: $edit.val(),
      operate: 'mkdir'
    }
    rename.el.select()
    $('.mkdir-confirm').off().click(function(e) {
      handleMkdir(e);
    })
    $('.mkdir-input').keydown(function(e) {
      if (e.keyCode !== 13) return
      handleMkdir(e);
    })
  })

  $('.floder-list-title').on('click', '.checkbox', function() {
    if (rename || !$('.listing').children().length) return
    if ($('.floder-list-title .checkbox').hasClass('active')) {
      $('.floder-list-title .checkbox').removeClass('active');
      $('.floder-list:not(.floder-list-min)').removeClass('active').find('.checkbox').removeClass('active').attr('data-checked', 'off')
      checkNum = 0;
      $('.operate-container .delete-files').addClass('disabled');
      $('.floder-list-title .name').text('Name')
    } else {
      $('.floder-list-title .checkbox').addClass('active')
      var $els = $('.floder-list:not(.floder-list-min)')
      var len = $els.length
      for (var i = 0; i < len; i++) {
        if (!$els.eq(i).hasClass('active')) {
          $els.addClass('active').find('.checkbox').addClass('active').attr('data-checked', 'on')
        }
      }
      checkNum = len;
      $('.operate-container .delete-files').removeClass('disabled');
      $('.floder-list-title .name').text(checkNum + ' file(s) selected');
    }
  })

  $('.listing').on('click', '.floder-list .checkbox', function() {
    if (rename) return
    if ($(this).attr('data-checked') === 'off') {
      $(this).attr('data-checked', 'on');
      checkNum+=1;
      $('.operate-container .delete-files').removeClass('disabled');
      $('.floder-list-title .name').text(checkNum + ' file(s) selected.');
      if ($('.floder-list:not(.floder-list-min)').length === checkNum) {
        $('.floder-list-title .checkbox').addClass('active');
      }
    } else {
      $(this).attr('data-checked', 'off');
      checkNum-=1;
      checkNum ? $('.floder-list-title .name').text(checkNum + ' file(s) selected.') : $('.floder-list-title .name').text('Name');
      if (!checkNum) {
        $('.operate-container .delete-files').addClass('disabled');
      }
      if ($('.floder-list-title .checkbox').hasClass('active')) {
        $('.floder-list-title .checkbox').removeClass('active');
      }
    }
    $(this).toggleClass('active').parent().toggleClass('active');
  })

  $('.listing').on('click', '.floder-list .operate .rename', function(e) {
    e.stopPropagation()
    if (rename) return
    $(this).parent().parent().css('justify-content', 'flex-start')
    var $edit = $(this).parent().siblings('.edit-container').find('input');
    if ($(this).attr('data-type') === 'dir') {
      $(this).parent().hide().siblings('.edit-container').show().siblings('.dir').find('span').hide();
      $edit.select()
      rename = {
        el: $edit,
        val: $edit.val(),
        type: 'dir'
      }
    } else {
      var val = $edit.val()
      var formate = val.split('.')[val.split('.').length - 1]
      var index = val.indexOf(formate)
      $(this).parent().hide().siblings('.edit-container').show().siblings('.file').find('span').hide()
      selectText($edit[0], 0, index - 1)
      rename = {
        el: $edit,
        val: $edit.val(),
        type: 'file'
      }
    }
  })

  $('.listing').on('click', '.floder-list .operate .delete', function(e) {
    e.stopPropagation()
    if (rename) return
    $('.confirm-delete-dialog').show()
    var name = $(this).parent().parent().data('name');
    deleteCon = {
      deleteArr: [{path: encodeURI(_path === '/' ? _path + name : _path + '/' + name)}],
      type: 'single'
    }
  })

  function handleRename (e, $el, type) {
    e.stopPropagation();
    var val = type === 'keydown' ? $el.val().trim() : $el.siblings('input').val().trim();
    if (rename.val === val || !val) {
      resetEdit();
      return
    }
    if (currDirs.length && rename.type === 'dir') {
      for (var i = 0; i < currDirs.length; i++) {
        if (val === currDirs[i]) {
          handleAlert('Same folder name exists, please modify.', 1000)
          rename.el.focus();
          return
        }
      }
    }
    if (currFiles.length && rename.type === 'file') {
      for (var i = 0; i < currFiles.length; i++) {
        if (val === currFiles[i]) {
          handleAlert('Same file name exists, please modify.', 1000)
          rename.el.focus();
          return
        }
      }
    }
    if (!checkName(val, rename)) return
    var path;
    if (rename.type === 'dir') {
      path = _path + '/' + $el.parent().siblings('.dir').data('name')
    } else {
      path = $el.parent().siblings('.file').attr('href')
    }
    $.ajax({
      type: 'POST',
      url: '/renameormakedir?type=renamefile&filename=' + val + '&filepath=' + encodeURIComponent(path) ,
      dataType: 'json',
    }).done(function(){
      _reload(_path);
      rename = null
    }).fail(function(jqXHR, textStatus, errorThrown) {
      handleAlert('Fail to rename file.')
      resetEdit()
      rename = null;
      return
    })
  }

  $('.listing').on('click', '.floder-list .edit-container .edit-confirm', function(e) {
    handleRename(e, $(this));
  })

  $('.listing').on('keydown', '.floder-list .edit-container input:not(.mkdir-input)', function (e) {
    if (e.keyCode !== 13) return
    handleRename(e, $(this), 'keydown');
  })

  function resetEdit () {
    rename.el.val(rename.val)
    var $container = rename.el.parent().hide().parent().css('justify-content', 'space-between')
    if (rename.type === 'file') {
      $container.find('.file').find('span').show()
    } else {
      if (rename.operate) {
        $('.listing').children().first().remove();
      } else {
        $container.find('.dir').find('span').show()
      }
    }
    $container.find('.operate').css('display', '')
    rename = null
  }

  function handleAlert (text, second) {
    var time = second ? second : 2000;
    $('.alert-info span').text(text);
    $('.alert-container').show();
    setTimeout(function() {
      $('.alert-container').hide();
    }, time)
  }

  function checkName (val, rename) {
    if (/[\\\/:*?'<>|]/i.test(val)) {
      if (rename.type === 'dir') {
        rename.el.select()
      } else {
        var val = rename.el.val()
        var formate = val.split('.')[val.split('.').length - 1]
        var index = val.indexOf(formate)
        selectText(rename.el[0], 0, index - 1)
      }
      handleAlert('A filename cannot contain special characters, such as <>|*?\\:\'/', 3000)
      return false
    } else {
      return true
    }
  }

  function selectText(textbox, startIndex, stopIndex){
    if (textbox.setSelectionRange) {
      textbox.setSelectionRange(startIndex, stopIndex);
    } else if (textbox.createTextRange) {//IE
      var range = textbox.createTextRange();
      range.collapse(true);
      range.moveStart('character', startIndex);
      range.moveEnd('character', stopIndex - startIndex);
      range.select();
    }
    textbox.focus();
  }

  $(document).click(function(e) {
    if (rename && e.target.tagName.toLowerCase() !== 'input') {
      resetEdit()
    }
  })

  $('.confirm-delete-dialog .close-delete').click(function() {
    $('.confirm-delete-dialog').hide()
    deleteCon = null;
  })

  $('.confirm-delete-dialog .confirm-delete').click(function () {
    if (deleteCon) {
      deleteFiles(deleteCon)
    }
  })

  $('.delete-files').click(function () {
    if (checkNum && !rename) {
      var $els = $('.floder-list:not(.floder-list-min)')
      var len = $els.length
      deleteCon = {
        deleteArr: [],
        type: 'Multiple'
      }
      for (var i = 0; i < len; i++) {
        if ($els.eq(i).hasClass('active')) {
          var name = $els.eq(i).children('.name').data('name')
          deleteCon.deleteArr.push({path: encodeURI(_path === '/' ? _path + name : _path + '/' + name)})
        }
      }
      $('.confirm-delete-dialog').show();
    }
  })

  function deleteFiles (path) {
    var form = new FormData();
    form.append('filepaths', JSON.stringify(path.deleteArr))
    $('.delete-loading').addClass('show');
    $.ajax({
      type: 'POST',
      url: '/deleltefiles',
      data: form,
      processData: false,
      contentType: false,
      dataType: 'json',
    }).done(function(){
      if (deleteCon.type === 'multiple') {
        $('.floder-list-title .name').text('Name')
        if ($('.floder-list-title .checkbox').hasClass('active')) {
          $('.floder-list-title .checkbox').removeClass('active');
        }
      }
      deleteCon = null
      $('.confirm-delete-dialog').hide()
      _reload(_path);
    }).fail(function(jqXHR, textStatus, errorThrown) {
      handleAlert('Fail to delete file.')
      deleteCon = null
      $('.confirm-delete-dialog').hide()
      _reload(_path);
      return
    })
  }
  
});
